/*
 Copyright (c) 2014 Shinji Tsuneyuki
 This file is distributed under the terms of the GNU General Public License version 3.
 */

/*!
 \file main.cc
 \brief CvO
*/

/*!
  \mainpage

  W[̈ꗗ:

  - main.cc	CvO
  - window.h window.cc	CEBhENX
  - dtmodel.h dtmodel.cc	f[^̓NX
  - dtlattice.h dtlattice.cc	iqf[^̓NX
  - dtcell.h dtcell.cc	iq̒PʖEf[^̃NX
  - dtatoms.h dtatoms.cc	iq̌qzuf[^̃NX
  - dtfield.h dtfield.cc	OtB[hf[^̃NX
  - dtband.h dtband.cc	ohf[^̃NX
  - glatoms.h glatoms.cc	iq̌qGL\̃NX
  - glbonds.h glbonds.cc	iq̌GL\̃NX
  - glcell.h glcell.cc	iq̒PʖEGL\̃NX
  - glbase.h glbase.cc	GLIuWFNg̕`{NX
  - glmisc.h glmisc.cc	GL̂̑̏
  - gloption.h gloption.cc	GL\̑SĂ̕\w
  - qtlattice.h qtlattice.cc	iqGUI\̓NX
  - qtcell.h qtcell.cc	iq̒PʖEGUI\̃NX
  - qtwidgets.h qtwidgets.cc	t@\GUIiNX
  - qtexception.h qtexception.cc	QTG[ΉNX
  - qtxml.h qtxml.cc	XMLf[^ǍNX
  - matrix.h matrix.cc	3x3sNX
  - position.h	3WNX
  - imatrix.h imatrix.cc	3x3s+3LxNgNX
  - fraction.h	LNX
  - symbol.h	fLNX
*/

#include <QtGui/QApplication>
#include "window.h"

int main( int argc, char* argv[] )
{
  const QString curdir = QDir::currentPath();
  const QString bindir = getDirName(QDir::fromNativeSeparators(argv[0]));
  QDir::setCurrent( bindir );

  QApplication app(argc, argv);

  MainWindow window;

  QDir::setCurrent( curdir );

  if( argc == 5 ){
    window.convert(argv[1],argv[2],argv[3],argv[4]);
    return 0;
  }
  window.show();
  if( argc == 3 ){
    window.load(argv[1],argv[2]);
  }
  if( argc == 2 ){
    window.load(argv[1]);
  }

  return app.exec();
}

